<?php

/* message.php: Page for reading messages 
*
    Copyright (C) 2002,2003,2004  Hastymail Development group

    This file is part of Hastymail.

    Hastymail is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Hastymail is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Hastymail; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

* $Id: message.php,v 1.402 2004/08/23 16:25:29 sailfrog Exp $
*/

require_once('../lib/wrapper_functions.php');

/* collect and validate incoming vars */
$hm_input = hm_validate_input($_POST, $_GET, 'message');

/* set ini values and check/get the SESSION vars */
if (hm_session_continue($hm_input['id'], $config_file)) {
    $config = $_SESSION['config'];
}

/* some basic init stuff */
$hm_input['id'] = session_id();
$str = $_SESSION['str'];

if (isset($hm_input['destination'])) {
    $dest = $hm_input['destination'];
}
elseif (isset($_SESSION['move_to_destination'])) {
    $dest = $_SESSION['move_to_destination'];
}
else {
    $dest = 'INBOX';
}
$_SESSION['move_to_destination'] = $dest;

/* check for raw message view */
if (isset($hm_input['raw'])  && $hm_input['raw'] == 1) {
    $raw = true;
}
else {
    $raw = false;
}

/* check for full header viewing status */
if (isset($hm_input['full']) && $hm_input['full'] == 'yes') {
    $full = true;
    $_SESSION['full'] = 'yes';
}
elseif (isset($hm_input['full']) && $hm_input['full'] == 'no') {
    $full = false;
    $_SESSION['full'] = false;
    unset($_SESSION['full']);
}
elseif (isset($_SESSION['full']) && $_SESSION['full'] == 'yes') {
    $full = true;    
}
else {
    $full = false;
}

/* hidden folder view setting */
if (isset($hm_input['hide_folder_preview'])) {
    if ($hm_input['hide_folder_preview'] == 1) {
        $preview_hide = true;
    }
    else {
        $preview_hide = false;
    }
}
else {
    if (isset($_SESSION['hide_folder_preview']) &&
        $_SESSION['hide_folder_preview'] == 1) {
        $preview_hide = true;
    }
    else {
        $preview_hide = false;
    }
}
$_SESSION['hide_folder_preview'] = $preview_hide;
if (isset($_SESSION['settings']['preview_position']) &&
    $_SESSION['settings']['preview_position'] == 1) {
    $preview_pos = 'bottom';
}
else {
    $preview_pos = 'top';
}

/* login to imap */
if (!$imap_stream = hm_imap_login($_SESSION['user'], $_SESSION['pass'], $config,
                                  $hasty_key, false, false)) {
    hm_logged_out($config_file);
}

/* check for simple option and set flag */
$simple = false;
if ((isset($_SESSION['settings']['simple']) && $_SESSION['settings']['simple'] == 'true')
   || (isset($_SESSION['auto_simplify']) && $_SESSION['auto_simplify'] == 'true')) {
    $simple = true;
}

/* check for keep_as_new */
if (isset($hm_input['keep_as_new'])) {
    hm_select_mailbox($imap_stream, $hm_input['kan_folder']);
    hm_imap_action($imap_stream, $hm_input['kan_uid'], 'UNREAD', false, false);
}

/* get unseen info */
$unseen = hm_unseen_status ($imap_stream, $_SESSION['folders']);

/* check for bottom previous and next links */
if (isset($hm_input['next_normal'])) {
    $hm_input['uid'] = $hm_input['next_uid_normal'];
}
elseif (isset($hm_input['previous_normal'])) {
    $hm_input['uid'] = $hm_input['previous_uid_normal'];
}

/* adjust new message count */
if ((isset($_SESSION['next_flag']) && $hm_input['uid'] == $_SESSION['next_flag'] &&
    isset($_SESSION['next_new']) && $_SESSION['next_new'] == 1) ||
    (isset($_SESSION['prev_flag']) && $hm_input['uid'] == $_SESSION['prev_flag'] &&
    isset($_SESSION['prev_new']) && $_SESSION['prev_new'] == 1) ||
    (isset($hm_input['new']) && $hm_input['new'] == 1)) {
    if (isset($unseen[urldecode($hm_input['mailbox'])])) {
        if ($unseen[urldecode($hm_input['mailbox'])] > 0) {
            $unseen[urldecode($hm_input['mailbox'])] -= 1;
        }
    }
}
/* clean up flags */
if (isset($_SESSION['prev_flag'])) {
    unset($_SESSION['prev_flag']);
    unset($_SESSION['prev_new']);
}
if (isset($_SESSION['next_flag'])) {
    unset($_SESSION['next_flag']);
    unset($_SESSION['next_new']);
}
if (isset($_SESSION['current_flags'])) {
    unset($_SESSION['current_flags']);
}

/* search for message response */
if (isset($hm_input['find_response'])) {
    if (isset($_SESSION['settings']['sent_folder'])) {
        hm_select_mailbox($imap_stream, $_SESSION['settings']['sent_folder']);
        $search = 'SEARCH HEADER in-reply-to '.
        str_replace(array('&gt;', '&lt;'), '', $hm_input['find_response']);
        $res = hm_search_mailbox($imap_stream, $search, false);
        if (strstr($res, ' ')) {
            $res = trim(substr($res, 0, strpos($res, ' ')));
        }
        else {
            $res = trim($res);
        }
        if (is_numeric($res)) {
            $hm_input['mailbox'] = $_SESSION['settings']['sent_folder'];
            $hm_input['uid'] = $res;
        }
        else {
            $_SESSION['notices'][] = $str[254];
        }
    }
}

/* select the mailbox for imap */
hm_select_mailbox($imap_stream, $hm_input['mailbox']);

/* check if we can use the cache */
$cache = hm_check_cache($hm_input['mailbox']);

/* get sort information */
if (!isset($hm_input['page_num'])) {
    $hm_input['page_num'] = '0';
}
if (isset($_SESSION['settings']['sort']) 
          && array_key_exists($hm_input['mailbox'], $_SESSION['settings']['sort'])) {
    $sort = $_SESSION['settings']['sort'][$hm_input['mailbox']];
} 
else {
    $sort = 'ARRIVAL';
}
$reuse = true;
if (isset($_SESSION['sort_filter'][$hm_input['mailbox']])) {
    $filter = $_SESSION['sort_filter'][$hm_input['mailbox']];
}
else {
    $filter = false;
}
if ($cache && isset($_SESSION['sort_data'][$hm_input['mailbox']])) {
    $sort_info = $_SESSION['sort_data'][$hm_input['mailbox']];
}
else {
    $reuse = false;
    $sort_info = &hmw_get_sort_info($imap_stream, $sort, $hm_input['mailbox'], false,
                                    $filter);
}

/* process move and delete actions */
switch (true) {
    case isset($hm_input['move']):
        $action = 'move';
        break;
    case isset($hm_input['sort']):
        $action = 'sort';
        break;
    case isset($hm_input['delete']):
        $action = 'delete';
        break;
    case isset($hm_input['read']):
        $action = 'read';
        break;
    case isset($hm_input['unread']):
        $action = 'unread';
        break;
    case isset($hm_input['copy']):
        $action = 'copy';
        break;
    default:
        $action = false;
        break;
}

if ($action) {
    $dest = false;
    $action_uid = false;
    if (isset($hm_input['destination'])) {
        $dest = $hm_input['destination'];
    }
    if ($action == 'delete') {
        $action_uid = $hm_input['uid_delete'];
    }
    elseif ($action == 'move') {
        $action_uid = $hm_input['uid_move'];
    }
    if ($action_uid) {
        if ($action == 'delete' && isset($hm_input['skip_trash'])) {
            $skip = true;
        }
        else {
            $skip = false;
        }
        $result = hm_message_controls($action, $imap_stream,
                  $action_uid, $dest, false, false, $hm_input['mailbox'], 
                  1, $str[26], $skip);
    }   
    if (isset($_SESSION['thread_data'][$hm_input['mailbox']])) {
        unset($_SESSION['thread_data'][$hm_input['mailbox']]);
    }
    $sort_info = &hmw_get_sort_info($imap_stream, $sort, $hm_input['mailbox'], false,
                                    $filter);
}

/* bail if the message is gone */
if (!in_array($hm_input['uid'], $sort_info[2])) {
    if ($cache) {
        $sort_info = &hmw_get_sort_info($imap_stream, $sort, $hm_input['mailbox'], false);
    }
    if (!in_array($hm_input['uid'], $sort_info[2])) {
        $_SESSION['notices'][] = $str[256];
        if (isset($hm_input['search']) && $hm_input['search'] == 1) {
            $_SESSION['notices'][] = $str[216].'<br>'.$str[217];
            header("Location: ".$config['hostname'].$config['install_path'].
                "search.php?id=".$hm_input['id']."&mailbox=".$hm_input['mailbox']);
            exit;
        }
        else {
            $_SESSION['notices'][] = $str[218];
            header("Location: ".$config['hostname'].$config['install_path'].
                "mailbox.php?id=".$hm_input['id']."&mailbox=".$hm_input['mailbox']);
            exit;
        }
    }
    else {
        if ($filter) {
            if (isset($_SESSION['sort_filter'][$hm_input['mailbox']])) {
                unset($_SESSION['sort_filter'][$hm_input['mailbox']]);
                $_SESSION['notices'][] = 
                    'Had to disable folder sort filter to open this message';
            }
        }
    }
}

/* get message structure */
$structure = hm_get_struct($imap_stream, $hm_input['uid']);
//$structure = hm_get_struct2($imap_stream, $hm_input['uid']);

//print_r($structure);
//print_r(hm_get_struct2($imap_stream, $hm_input['uid']));


/* check for drafts */
$draft = false;
if (isset($_SESSION['settings']['drafts_folder']) && urldecode($hm_input['mailbox']) ==
    $_SESSION['settings']['drafts_folder']) {
    $tmp = &hm_get_messages($hm_input['uid'], $imap_stream);
    $flags = $tmp[$hm_input['uid']][5];
    if (stristr($flags, 'draft')) {
        $draft = true;
    }
}

/* check for full message display on LARGE message parts */
$_SESSION['cutoff'] = 0;
unset($_SESSION['cutoff']);
if (isset($hm_input['big_text'])) {
    $cutoff = false;
    $pview_tag = '&amp;big_text=true';
}
else {
    $cutoff = true;
    $pview_tag = '';
}

/* get message headers */
$message_headers = hm_get_full_header($imap_stream, $hm_input['uid'], false);
$subject = $str[229];
if (isset($message_headers['subject']) && $message_headers['subject'] != '') {
    $subject = $message_headers['subject'];
}
$date = $str[231];
if (isset($_SESSION['settings']['date_string'])) {
    $date_string = $_SESSION['settings']['date_string'];
}
else {
    $date_string = 'g:i a, F j, Y';
}
if (isset($message_headers['date']) && $message_headers['date'] != '') {
    $date = date($date_string, (strtotime($message_headers['date'])));
}
$from = $str[230];
if (isset($message_headers['from']) && $message_headers['from'] != '') {
    $from = stripslashes($message_headers['from']);
}
$to = $str[232];
if (isset($message_headers['to']) && $message_headers['to'] != '') {
    $to = $message_headers['to'];
}
$cc = false;
if (isset($message_headers['cc']) && $message_headers['cc'] != '') {
    $cc = $message_headers['cc'];
}
$xmailer = false;
if (isset($message_headers['x-mailer']) && $message_headers['x-mailer'] != '') {
    $xmailer = $message_headers['x-mailer'];
}
elseif (isset($message_headers['user-agent']) && $message_headers['user-agent'] != '') {
    $xmailer = $message_headers['user-agent'];
}

/* check for mailing list header */
$message_list_reply = false;
if (isset($message_headers['list-post'])) {
    if (preg_match("/&lt;mailto:(.+)&gt;/i", $message_headers['list-post'], $matches)) {
        $message_list_reply = true;
        $message_list_reply_to = $matches[1]; 
    }
}
elseif (isset($message_headers['x-list-post'])) {
    if (preg_match("/&lt;mailto:(.+)&gt;/i", $message_headers['x-list-post'], $matches)) {
        $message_list_reply = true;
        $message_list_reply_to = $matches[1]; 
    }
}
elseif (isset($message_headers['x-mailing-list'])) {
    if (preg_match("/([^\s]+@[^\s]+)/i", $message_headers['x-mailing-list'], $matches)) {
        $message_list_reply = true;
        if (isset($matches[1])) {
            $message_list_reply_to = $matches[1]; 
        }
        else {
            $message_list_reply_to = '';
        }
    }
}

/* message display */
list($hm_input['page_num'], $message_dsp_header, $mailbox_title) =
          hm_message_header ($sort_info, $hm_input['mailbox'], $imap_stream,
                                         $hm_input['page_num'], $hm_input['id'], 
                                         $hm_input['uid'], $_SESSION['dsp_folders'], 
                                         $simple);


/* bounce notices */
if (isset($hm_input['bounce_notice'])) {
    if ($hm_input['bounce_notice'] == 'yes') {
        $_SESSION['notices'][] =  $str[223];
    }
    else {
        $_SESSION['notices'][] =  $str[224];
    }
}
/* check for missing folders */
hm_check_folders($imap_stream);

/* toolbar and any status messages */
hm_toolbar($imap_stream, $hm_input['mailbox'], $unseen, false, $str[26], false, 
           $hm_input['uid'], true);
/* message part selection */
if (!$raw) {
    if (!isset($hm_input['part'])) {
        $part = 0;
        /* blah, html default option! */
        if (isset($_SESSION['settings']['html_default']) &&
            $_SESSION['settings']['html_default'] == 'true') {
            foreach ($structure as $index => $array) {
                if (isset($array['subtype']) && $array['subtype'] == 'html') {
                    $part = $index;
                    break;
                }
            }
        }
    }
    else {
        $part = $hm_input['part'];
    }
    if (isset($hm_input['parts'])) {
        $part_value = $hm_input['parts'];
    }
    else {
        $part_value = '';
    }
}
else {
    $part = 0;
    $part_value = '';
}

/* main message display */
echo '
<input type="hidden" name="mailbox" value="',$hm_input['mailbox'],'">
<input type="hidden" name="part" value="',$part,'">
<input type="hidden" name="uid" value="',$hm_input['uid'],'">
<input type="hidden" name="page_num" value="',$hm_input['page_num'],'">
<input type="hidden" name="parts" value="',$part_value,'">',"\n";

if ($simple) {
    echo $message_dsp_header,'&nbsp;&nbsp;';
}
else {
    echo '<br>
<table width="95%" align="center" cellpadding="4" cellspacing="4" class="tables5">
   <tr>
',$message_dsp_header;
echo '      <input type="checkbox" value="1" name="keep_as_new">
     <small>',$str[294],'</small>&nbsp;';

    /* prev/next/back links for search results */
    if (isset($hm_input['search']) && $hm_input['search'] == 1) {
        echo '         </td>
         <td class="tables2" align="center" nowrap>
         &nbsp;',
             hm_create_next_previous ($imap_stream, $_SESSION['search_info'],
                                       $hm_input['mailbox'], $hm_input['uid'], 'search',
                                       true, $str[257], false, false, false),'&nbsp;';
    }

    /* prev/next/back links for thread results */
    elseif (isset($hm_input['thread']) && $hm_input['thread'] == 1) {
        echo '         </td>
         <td class="tables2" align="center" nowrap>
         &nbsp;',
             hm_create_next_previous ($imap_stream, $_SESSION['thread_data'],
                                      $hm_input['mailbox'], $hm_input['uid'], 'thread',
                                      false, $str[221], true, false, false),'&nbsp;';
    }
    echo '      </td>
      <td class="tables2" align="right">',"\n",$mailbox_title;
    if ($filter) {
        echo '<b><small>(Filtered)</small></b>&nbsp;&nbsp;';
    }
}
$del_range = array();
if (isset($_SESSION['prev_flag'])) {
    $del_range[] = $_SESSION['prev_flag'];
}
$del_range[] = $hm_input['uid'];
if (isset($_SESSION['next_flag'])) {
    $del_range[] = $_SESSION['next_flag'];
}

if ($simple) {
    echo '<br><br>';
}
else {
    echo '      </td>
   </tr>
</table>
<table width="95%" align="center" cellpadding="4" cellspacing="4"',
         ' class="tables5">
   <tr>
      <td colspan="3">',"\n";
    /* folder preview option */
    if (isset($_SESSION['settings']['folder_preview']) &&
        $_SESSION['settings']['folder_preview'] != 'none' &&
        $preview_pos == 'top') {
        if (!$preview_hide) {
            if (isset($hm_input['scroll_uid'])) {
                $scroll_uid = $hm_input['scroll_uid'];
            }
            else {
                $scroll_uid = $hm_input['uid'];
            }
            hm_folder_preview($imap_stream, $scroll_uid, $sort_info, $hm_input['id'],
                              $hm_input['mailbox'], $hm_input['uid']);
        }
    }
    echo '      </td>
   </tr>
   <tr>',"\n";
    /* full/small header links */
    echo '      <td class="tables2" nowrap colspan="2">
      &nbsp;';
}
if ($full) {
    echo '<input type="submit" value="',$str[30],
         '" name="small_headers" class="button3">',"\n";
}
else {
    echo '<input type="submit" value="',$str[29],
         '" name="full_headers" class="button3">',"\n";
}
if (!$simple) {
    /* raw/normal message links */
    if ($raw) {
        echo '      &nbsp;&nbsp;<input type="submit" value="',$str[32],
             '" name="normal_view" class="button3">',"\n";
    }
    else {    
        echo '      &nbsp;&nbsp;<input type="submit" value="',$str[31],
             '" name="raw_view" class="button3">',"\n";
    }

    /* thread view */
    if ((isset($_SESSION['config']['client_sort']) && $_SESSION['config']['client_sort']
        == 'false') || !isset($_SESSION['config']['client_sort'])) {
        if (isset($_SESSION['caps']) && stristr($_SESSION['caps'], 'THREAD')) {
            echo '      &nbsp;&nbsp;<input type="submit" name="thread_view" value="',
                 $str[33],'" class="button3">',"\n";
        }
    }
    if ($full) {
        echo '      <input type="hidden" name="full" value="yes">',"\n";
    }
    if ($raw) {
        echo '      <input type="hidden" name="raw" value="1">',"\n";
    }
    echo '      &nbsp;&nbsp;<input type="submit" value="',$str[34],
         '" name="print_view" class="button3">',"\n";

    /* folder view link */
    if ($preview_hide) {
        echo '      &nbsp;&nbsp;<input type="submit" value="','Folder view',
             '" name="folder_view" class="button3">',"\n";
    }
    echo '      </td>
      <td align="center" class="tables2" nowrap width="10%">';

    echo  hm_create_next_previous ($imap_stream, $del_range, $hm_input['mailbox'], 
                              $hm_input['uid'], 'move', false, $str[0], false, false,
                              true);
    echo '      &nbsp;<input type="hidden" name="uid_move" value="',$hm_input['uid'],'">
      &nbsp;<select class="select3" name="destination">',"\n";
    hm_folder_options($_SESSION['move_to_destination'], false, $simple, false, 
                      'class="option3"');
    echo "      </select>&nbsp;\n";
    echo '      </td>
   </tr>',"\n";
    if ($raw) {
        echo '</table>
<table width="95%" align="center">',"\n";
    }
    echo '   <tr>
      <td class="tables4" colspan="3">
      <table width="100%" cellpadding="1" cellspacing="1">
          <tr>',"\n";

}

/* full headers */
if ($full && !$raw) {
    if (!$simple) {
        echo '
            <td width="100%">
            <table cellpadding="1" cellspacing="0">',"\n";
        foreach ($message_headers as $name => $val) {
            echo '               <tr>
                  <td align="right">
                  <small><b>',preg_replace("/_\d*$/", '', $name),':</b></small>
                  </td> 
                  <td valign="top">
                  &nbsp;<small>',$val,'</small>
                  </td> 
               </tr>',"\n";
        }
        echo '
            </table>
            </td>
         </tr>';
    }
    else {
    echo "<br><small>\n";
        foreach ($message_headers as $name => $val) {
            echo preg_replace("/_\d+/", '', $name).':&nbsp;'.$val.'<br>';
        }
        echo "    </small>";
    }
}

/* small headers */
elseif (!$raw) {
    if (!$simple) {
        $our_ids = array();
        if (isset($_SESSION['profiles'])) {
            foreach ($_SESSION['profiles'] as $array) {
                if (isset($array['from_address']) && $array['from_address'] != '') {
                    $our_ids[] = $array['from_address'];
                }
            }
        }
        if (preg_match("/[^\s]+@[^\s]+/", $from, $matches)) {
            $from_addy = str_replace(array('&gt;', '&lt;'), '', $matches[0]);
            $from_name = trim(str_replace(array($from_addy, '"', '&gt;', '&lt;', ')',
                         '('), '', $from));
            if ($from_name == '') {
                $from_name = $from_addy;
            }
            if (!in_array($from_addy, $our_ids)) {
                $from = str_replace($from_addy, '<a class="font2" href="contacts.php?id='.
                        $hm_input['id'].'&amp;prep=Add&amp;prep_addy='.$from_addy.
                        '&amp;name='.$from_name.'&amp;from_message='.$hm_input['uid'].
                        '&amp;mailbox='.$hm_input['mailbox'].
                        '">'.$from_addy.'</a>', $from);
            }
        }
        echo '            <td>
            <table cellpadding="0" cellspacing="0">
               <tr class="tables4">
                  <td valign="top">
                  ',$str[21],':&nbsp;&nbsp;
                  </td>
                  <td valign="top">
                  ',$subject,'
                  </td>
               </tr>
               <tr class="tables4">
                  <td valign="top">
                  ',$str[22],':
                  </td>
                  <td valign="top">
                  ',$from,'
                  </td>
               </tr>
               <tr class="tables4">
                  <td valign="top">
                  ',$str[23],':
                  </td>
                  <td valign="top">
                  ',hm_htmlize($date),'
                  </td>
               </tr>
               <tr class="tables4">
                  <td valign="top">
                  ',$str[25],':
                  </td>
                  <td valign="top">',"\n";
    }
    else {
        echo '<br>',$str[21],': ',$subject,"\n",'<br>',$str[22],': ',$from,"\n<br>",
             $str[23],': ',hm_htmlize($date),"\n<br>",$str[25],': ';
    }
    if (strlen($to) > 200) {
        echo '                   ',substr($to, 0, 200 + strpos(substr($to, 200), ',')),
             "...\n";
    }
    else {
        echo '                   ',$to,
             "\n";
    }
    if (!$simple) {
        echo '                  </td>
               </tr>',"\n";
    }
    if ($cc) {
        if (!$simple) {
            echo '               <tr class="tables4">
                  <td valign="top">
                  ',$str[87],':
                  </td>
                  <td valign="top">',"\n";
        }
        else {
            echo '<br>',$str[87],': ';
        }
        if (strlen($cc) > 200) {
            echo '                   ',substr($cc, 0, 200 + strpos(substr($cc, 200), 
                 ',')), "...\n";
        }
        else {
            echo '                   ',$cc,
                 "\n";
        }
        if (!$simple) {
            echo '                  </td>
               </tr>',"\n";
        }
    }
    if ($xmailer) {
        if (!$simple) {
            echo '               <tr class="tables4">
                  <td valign="top">
                  Client:
                  </td>
                  <td valign="top">',"\n";
        }
        else {
            echo '<br>Client: ';
        }
        echo '                   ',$xmailer,
                 "\n";
        if (!$simple) {
            echo '                  </td>
               </tr>',"\n";
        }
    }
    if (!$simple) {
        echo '            </table>
            </td>
         </tr>',"\n";
    }
    else {
        echo '<br>';
    }
}
if (!$simple && !$raw) {
    echo '       </table>
       </td>
   </tr>
   <tr>',"\n";
}
/* reply | reply all | reply to list | forward links */
if (!$simple && !$raw) {
    echo '      <td class="tables2" nowrap colspan="2">
      &nbsp;',"\n";
}
if (!$raw) {
echo '      <input type="submit" name="reply" value="',$str[35],
     '" class="button3">',"\n";
echo '      &nbsp;&nbsp;<input type="submit" name="reply_all" value="',$str[36],
     '" class="button3">',"\n";
if ($message_list_reply) {
    echo '      &nbsp;<input type="hidden" value="',$message_list_reply_to,
         '" name="list_reply_to">
      <input type="submit" name="list_reply" value="',$str[40],'" class="button3">',"\n";
}
echo '      &nbsp;&nbsp;<input type="submit" value="',$str[37],
     '" name="forward" class="button3">',"\n";
if (isset($config['enable_bounce_option']) && $config['enable_bounce_option'] == 
    'true') {
    echo '      &nbsp;&nbsp;<input type="submit" name="bounce" value="',$str[222],
         '" class="button3">',"\n";
}
if ($draft) {
    echo '      &nbsp;&nbsp;<input type="submit" name="resume_draft" value="',$str[247],
         '" class="button3">',"\n";
}
else {
    echo '      &nbsp;&nbsp;<input type="submit" value="',
         $str[313].'" class="button3" name="edit_as_new">',"\n";
}
if (isset($message_headers['message-id'])
    && isset($_SESSION['current_flags']) && stristr($_SESSION['current_flags'], 
    'answered')) {
    echo '      ',
         '<input type="hidden" name="message_id" value="',$message_headers['message-id'],
         '">&nbsp;&nbsp;<input type="submit" name="find_response" value="',$str[253],
         '" class="button3">',"\n";
}
if (!$simple) {
    echo "      </td>\n";
}
else {
    echo '      &nbsp;&nbsp;&nbsp;&nbsp;';
}
/* prev/next/delete links */
if (!$simple) {
    echo '      <td class="tables2" nowrap>';
}
echo  hm_create_next_previous ($imap_stream, $del_range, $hm_input['mailbox'], 
                              $hm_input['uid'], 'delete', false, $str[4], false, false,
                              true),'      &nbsp;';
if (isset($_SESSION['settings']['trash_folder']) && 
    isset($_SESSION['settings']['skip_trash'])) {
    echo '&nbsp;&nbsp;&nbsp;<small>',$str[311],
         '</small> <input type="checkbox" value="1" name="skip_trash">',"\n";
}
if (!$simple) {
echo '      </td>
   </tr>
</table>
<table width="95%" align="center">
   <tr>
      <td class="tables4" colspan="3">',"\n";
}


}
/* if raw message view is selected */
if ($raw) {
    $text_part = hm_get_message_part($imap_stream, $hm_input['uid'], 'raw');
    echo '             <td>
             <table width="97%" align="center">
                <tr>
                   <td>
                   <pre>',hm_htmlize($text_part),'</pre>
                  </td>
               </tr>
            </table>
            </td>
         </tr>
      </table>
      </td>
   </tr>
</table>
<table width="95%" align="center" cellpadding="4" cellspacing="4"> ',"\n";
}
else {
    $part_search = false;
    if (isset($hm_input['parts'])) {
        $message_parts = explode(',', $hm_input['parts']);
    }
    elseif (isset($hm_input['view'])) {
        $message_parts = array();
        foreach ($_POST as $name => $value) {
            if (substr($name, 0, 3) == 'mp_') {
                $message_parts[] = str_replace('_', '.', substr($name, 3));
            }
        }
    }
    elseif ($part > 0) {
        $message_parts = array($hm_input['part']);
    }
    else {
        $part_search = true;
        $message_parts = array(1);
    }
    $start = true;
    $actual_parts = array();
    $displayed = array();
    foreach ($message_parts as $val) {
        if ($start) {
            $start = false;
        }
        else {
            echo '      </td>
   </tr>
   <tr>
      <td class="tables4" colspan="3">',"\n";
        }
        if (!$part_search) {
            $results = &hm_find_display_part($imap_stream, $structure, $hm_input['uid'], 
                                            $val, false, false, $cutoff);
        }
        else {
            $results = &hm_find_display_part($imap_stream, $structure, $hm_input['uid'], 
                                             false, false, false, $cutoff);
            if ($results[1] == "\n\n     ".$str[194]."\n\n" && 
                $structure[1]['type'].$structure[1]['subtype'] == 'texthtml' &&
                isset($_SESSION['settings']['html_only']) &&
                $_SESSION['settings']['html_only'] == 'true') {
                $results = &hm_find_display_part($imap_stream, $structure, 
                                                 $hm_input['uid'], 1, false, false,
                                                 $cutoff);
            }
        }
        $hm_input['part']= $results[0];
        $text_part = $results[1];
        $decode    = $results[2][0];
        $type      = $results[2][1];
        $subtype   = $results[2][2];
        $dsp_type  = $results[2][3];
        if (isset($results[2][5]) && $results[2][5]) {
            $name = $results[2][5];
        }
        /* setup charset mechanism */
        $code_page = false;
        $charset_convert = false;
        $charset = false;
        $utf = false;
        if (isset($results[2][4]) && $results[2][4] && $str['charset'] == 'UTF-8') {
            $charset = strtolower($results[2][4]);
            if (isset($_SESSION['charsets'][$charset])) {
                $code_page = $_SESSION['charsets'][$charset];
                $charset_convert = true;
            }
        }
        if ($charset == 'utf-8') {
            $utf = true;
        }
        /* check for rfc header information on nested parts */
        if (strstr($hm_input['part'], '.') && array_key_exists(1, $structure) &&
            !in_array(substr($hm_input['part'], 0, strrpos($hm_input['part'], '.')),
            $displayed)) {
            $value = &hm_in_multi_array($hm_input['part'], $structure, array(), true); 
            $part_headers = hm_get_full_header($imap_stream, $hm_input['uid'], $value[0]);
            /* check for mailing list header */
            if (isset($part_headers['list-post'])) {
                if (preg_match("/<mailto:([^>]+)>/i", $part_headers['list-post'],
                    $matches)) {
                    $list_reply = true;
                    $list_reply_to = $matches[1]; 
                }
            }
            elseif (isset($part_headers['x-list-post'])) {
                if (preg_match("/<mailto:([^>]+)>/i", $part_headers['x-list-post'],
                    $matches)) {
                    $list_reply = true;
                    $list_reply_to = $matches[1]; 
                }
            }
            else {
                $list_reply = false;
            }
        
            /* rfc message headers */
            if (is_array($part_headers)) {
                $feilds = array ('subject', 'from', 'date');
                if ($full && !$simple) { 
                    echo '      <table cellpadding="1" cellspacing="1">',"\n";
                    foreach ($part_headers as $key => $value) {
                        echo '         <tr>
            <td align="right">
            <small>&nbsp;<b>',$key,
            ':</b></small></td><td><small>&nbsp;&nbsp;',$value,'</small><br>
            </td>
        </tr>',"\n";
                    }
                }
                else {
                    if (!$simple) {
                        if (preg_match("/[^\s]+@[^\s]+/", $part_headers['from'], 
                            $matches)) {
                            $from_addy = str_replace(array('&gt;', '&lt;'), '',
                                         $matches[0]);
                            $from_name = trim(str_replace(array($from_addy, '"', '&gt;',
                                        '&lt;', '(', ')'), '', $part_headers['from']));
                            if ($from_name == '') {
                                $from_name = $from_addy;
                            }
                            $part_headers['from'] = str_replace($from_addy, 
                                    '<a class="font2" href="contacts.php?id='.
                                    $hm_input['id'].'&amp;prep=Add&amp;prep_addy='.
                                    $from_addy.'&amp;from_message='.$hm_input['uid'].
                                    '&amp;mailbox='.$hm_input['mailbox'].
                                    '&amp;name='.urlencode($from_name).'">'.$from_addy.
                                    '</a>',$part_headers['from']);
                        }
                        echo '      <table cellpadding="1" cellspacing="1">
         <tr>
            <td>
            &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;',
            $str[21],':&nbsp;&nbsp;
            </td>
            <td>
            ',$part_headers['subject'],'
            </td>
        </tr>
        <tr>
            <td>
            &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;',
            $str[22],':
            </td>
            <td>
            ',$part_headers['from'],'
            </td>
        </tr>
         <tr>
            <td>
            &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;',$str[23],':
            </td>
            <td>
            ',date($date_string, ( strtotime($part_headers['date']))),'
            </td>
        </tr>',"\n";
                    }
                    else {
                        echo '<br>',$str[21],': ',$part_headers['subject'],
                            $str['charset'],'<br>',$str[22],': ',$part_headers['from'],
                            '<br>Date: ',date($date_string, (strtotime(
                            $part_headers['date']))),"<br>\n";
                    }
                }
                if (!$simple) {
                    echo '      </table>
      </td>
   </tr>
   <tr>
      <td class="tables2" colspan="3">
      <table width="100%">
         <tr>
            <td nowrap colspan="3">&nbsp;&nbsp;',"\n";
                }
                echo '<input type="hidden" name="sub_part" value="',$hm_input['part'],
                     '"><input type="submit" value="',$str[41],
                     '" name="reply_part" class="button3">',"\n";
                echo '&nbsp;&nbsp;<input type="submit" name="reply_part_all" value="',
                     $str[36],'" class="button3">',"\n";
                if (isset($list_reply) && $list_reply) {
                    echo '&nbsp;&nbsp;<input type="submit" name="reply_part_list" value="'
                         ,$str[40],'" class="button3">',"\n";
                }
                echo '&nbsp;&nbsp;<input type="submit" name="forward_part" value="',
                     $str[225],'" class="button3">',"\n";
                if (!$simple) {
                    echo '            </td>
         </tr>
      </table>
      </td>
   </tr>
</table>
<table width="95%" align="center">
   <tr>
      <td class="tables4" colspan="3">',"\n";
                } 
            }
        }
        if ($simple) {
            echo '<br>';
        }
        switch (true) {
            case substr($dsp_type, 0, 5) == 'image':
                hm_print_image_part ($hm_input['id'], $hm_input['mailbox'],
                                     $hm_input['uid'], $hm_input['part'], $decode, 
                                     $type, $subtype, $name);
                break;
            case $dsp_type == 'texthtml':
                hm_print_html_part ($text_part, $charset_convert, $code_page, $charset,
                                    $message_headers, $hm_input['id']);
                break;
            case $dsp_type == 'textplain':
                hm_print_text_part ($text_part, $charset_convert, $code_page, $utf,
                                    $hm_input['id'], $hm_input['uid'], $hm_input['part'],
                                    $hm_input['mailbox']);
                break;
            default:
                if (!$simple) {
                    echo '      <table width="97%" align="center">
         <tr>
            <td>
            </td>
         </tr>
      </table>',"\n";
                }
                break;
        }
        $actual_parts[] = $hm_input['part'];
        $displayed[] = substr($hm_input['part'], 0, strrpos($hm_input['part'], '.'));
    }
}

/* message attachments display */
if (!$raw) {
    if (!$simple) {
        echo '      </td>
   </tr>
</table>
<table width="95%" align="center">
   <tr>
      <td colspan="3">
      <table width="100%" class="tables2" cellspacing="0" cellpadding="3" align="center">
         <tr class="tables1">
            <td align="center" colspan="6">
            <b>',$str[46],'</b>
            </td>
         </tr>
         <tr>
            <td colspan="3">
            </td>
            <td width="30%">
            <small><b>',$str[44],'</b></small>
            </td>
            <td width="60%">
            <small><b>',$str[45],'</b></small>
            </td>
            <td width="10%">
            <small><b>',$str[24],'</b></small>
            </td>
         </tr>',"\n";
    }
    else {
        echo '&nbsp;&nbsp;',$str[46],"\n";
    }
    $atag ='<a class="font2" href="message.php?uid='.$hm_input['uid'].
           '&amp;id='.$hm_input['id'].'&amp;mailbox='.urlencode($hm_input['mailbox']).
           '&amp;page_num='.$hm_input['page_num']."&amp;";
    hm_print_attachments($structure, $atag, 0, $message_part_types, $actual_parts, 
                         $simple);
    if (!$simple) {
        echo '         <tr class="tables2">
            <td colspan="6">
            &nbsp;&nbsp;<input type="submit" name="view" value="',$str[310],
            '" class="button3">
            </td>
         </tr>
      </table>
      </td>
   </tr>
</table>
<br>
<table width="95%" align="center" cellpadding="4" cellspacing="4">',"\n";
    }
    else {
        echo '<br><input type="submit" name="view" value="',$str[310],'" class="button3">
&nbsp;';
    }
}

/* search headers and body for email addresses */
$test_headers = array();
foreach ($message_headers as $index => $value) {
    switch (true) {
        case preg_match('/^received/', $index):
        case $index == 'message-id':
        case $index == 'resent-message-id':
        case $index == 'references':
        case $index == 'in-reply-to':
            break;
        default:
            $test_headers[] = $value;
            break;
    }
}
if (isset($part_headers)) {
    $test_part_headers = array();
    foreach ($part_headers as $index => $value) {
        switch (true) {
            case preg_match('/^received/', $index):
            case $index == 'message-id':
            case $index == 'resent-message-id':
            case $index == 'references':
            case $index == 'in-reply-to':
                break;
            default:
                $test_part_headers[] = $value;
                break;
        }
    }
    $part_string = implode(' ', $test_part_headers);
}
else {
    $part_string = '';
}
$test_string = implode(' ', $test_headers).' '.$part_string;
if (isset($dsp_type) && substr($dsp_type, 0, 4) == 'text') {
    $test_string .= ' '.$text_part;
}
if (preg_match_all("/([\.\-\_[:alnum:]]+@[\.\-\_[:alnum:]]{2,}\.[[:alnum:]]{2,})/i", 
                   $test_string, $matches)) {
    if (isset($matches[1])) {
        $get_addresses = array_unique($matches[1]);
    }
    else {
        $get_addresses = array();
    }
}

/* add to addressbook option */
if (!empty($get_addresses) && !$simple && isset($dsp_type)) {
echo '   <tr>',"\n",$message_dsp_header,'      </td>
      <td nowrap class="tables2" align="right">
      &nbsp;<input type="submit" value="',$str[43],'" name="prep" class="button3">
      <select class="select3" name="prep_addy">',"\n";
    foreach ($get_addresses as $addy) {
        echo '        <option class="option3" value="',
             hm_special_chars($addy, $str['charset'],
             $charset_convert, $code_page, $utf),"\">", 
             hm_special_chars($addy, $str['charset'], $charset_convert, 
                              $code_page, $utf),
             "</option>\n";
    }
    echo '      </select>',"\n";
}
/* prev+next links and folder link stored in $message_dsp_header */
elseif (!$simple) {
    echo '   <tr>
            ',$message_dsp_header,'
            </td>',"\n";
}
else {
    echo '&nbsp;',$message_dsp_header;
}

/* indicator for uid sort cache use */
if (!$simple) {
    if ($raw) {
        echo '      <td class="tables2" align="right">',"\n";    
    }
    if ($reuse) {   
        echo '      <small><small>(cached)</small></small>',"\n";      
    }   
    else {      
        echo '      <small><small>(fetched)</small></small>',"\n";     
    }
    echo '      &nbsp;&nbsp;<a class="font2" href="#top">',$str[324],
         '</a>&nbsp;&nbsp;',"\n";
    /* folder preview option */
    if (isset($_SESSION['settings']['folder_preview']) &&
        $_SESSION['settings']['folder_preview'] != 'none' &&
        $preview_pos == 'bottom') {
    echo '      </td>
    </tr>
</table>
<table width="95%" align="center" cellpadding="4" cellspacing="4"',
         ' class="tables5">
      <tr>
         <td colspan="3">',"\n";
        if (!$preview_hide) {
            if (isset($hm_input['scroll_uid'])) {
                $scroll_uid = $hm_input['scroll_uid'];
            }
            else {
                $scroll_uid = $hm_input['uid'];
            }
            hm_folder_preview($imap_stream, $scroll_uid, $sort_info, $hm_input['id'],
                              $hm_input['mailbox'], $hm_input['uid']);
        }
    }
    echo '      </td>
   </tr>
</table>',"\n";
}
echo '
</form>
</body>
</html>';

/* close imap connection */
hm_imap_logout($imap_stream); 

?>
